
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@                    S y m b O S   -   C o n s t a n t s                     @
;@                                                                            @
;@             (c) 2000-2008 by Prodatron / SymbiosiS (Jörn Mika)             @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


;P R O C E S S - I D S
.PRC_ID_KERNEL   equ 1   ;kernel process
.PRC_ID_DESKTOP  equ 2   ;desktop manager process
.PRC_ID_SYSTEM   equ 3   ;system manager process


;M E S S A G E S
;General
.MSC_GEN_QUIT    equ 0   ;application is beeing asked, to quit itself
.MSC_GEN_FOCUS   equ 255 ;application is beeing asked, to focus its window

;Kernel Commands
.MSC_KRL_MTADDP  equ 1   ;add process (P1/2=stack, P3=priority (7 high - 1 low), P4=ram bank (0-8))
.MSC_KRL_MTDELP  equ 2   ;delete process (P1=ID)
.MSC_KRL_MTADDT  equ 3   ;add timer (P1/2=stack, P4=ram bank (0-8))
.MSC_KRL_MTDELT  equ 4   ;delete timer (P1=ID)
.MSC_KRL_MTSLPP  equ 5   ;set process to sleep mode
.MSC_KRL_MTWAKP  equ 6   ;wake up process
.MSC_KRL_TMADDT  equ 7   ;add counter service (P1/2=address, P3=ram bank, P4=process, P5=frequency)
.MSC_KRL_TMDELT  equ 8   ;delete counter service (P1/2=address, P3=ram bank)
.MSC_KRL_TMDELP  equ 9   ;delete all counter services of one process (P1=process ID)

;Kernel Responses
.MSR_KRL_MTADDP  equ 129 ;process has been added (P1=0/1->ok/failed, P2=ID)
.MSR_KRL_MTDELP  equ 130 ;process has been deleted
.MSR_KRL_MTADDT  equ 131 ;timer process has been deleted (P1=0/1->ok/failed, P2=ID)
.MSR_KRL_MTDELT  equ 132 ;timer has been removed
.MSR_KRL_MTSLPP  equ 133 ;process is sleeping now
.MSR_KRL_MTWAKP  equ 134 ;process has been waked up
.MSR_KRL_TMADDT  equ 135 ;counter service has been added (P1=0/1->ok/failed)
.MSR_KRL_TMDELT  equ 136 ;counter service has been deleted
.MSR_KRL_TMDELP  equ 137 ;all counter services of a process have been deleted

;System Commands
.MSC_SYS_PRGRUN  equ 16  ;load application or document (P1/2=address filename, P3=ram bank filename)
.MSC_SYS_PRGEND  equ 17  ;quit application (P1=ID)
.MSC_SYS_SYSWNX  equ 18  ;open dialogue to change current window (next) (-)
.MSC_SYS_SYSWPR  equ 19  ;open dialogue to change current window (previouse) (vorheriges) (-)
.MSC_SYS_PRGSTA  equ 20  ;open dialogue to load application or document (-)
.MSC_SYS_SYSSEC  equ 21  ;open system secuity dialogue (-)
.MSC_SYS_SYSQIT  equ 22  ;open shut shown dialogue (-)
.MSC_SYS_SYSOFF  equ 23  ;shut down (-)
.MSC_SYS_PRGSET  equ 24  ;start control panel (P1=submodul -> 0=main window, 1=display settings, 2=date/time)
.MSC_SYS_PRGTSK  equ 25  ;start taskmanager (-)
.MSC_SYS_SYSFIL  equ 26  ;call filemanager function (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
.MSC_SYS_SYSHLP  equ 27  ;start help (-)
.MSC_SYS_SYSCFG  equ 28  ;call config function (P1=number, 0=load, 1=save, 2=reload background)
.MSC_SYS_SYSWRN  equ 29  ;open message/confirm window (P1/2=adresse, P3=ram bank, P4=number of buttons)
.MSC_SYS_PRGSRV  equ 30  ;shared service function (P4=type [0=search, 1=start, 2=release], P1/2=addresse 12char ID, P3=ram bank 12char ID or P3=program ID, if type=2)
.MSC_SYS_SELOPN  equ 31  ;open fileselect dialogue (P6=filename ram bank, P8/9=filename address, P7=forbidden attributes, P10=max entries, P12=max buffer size)

;System Responses
.MSR_SYS_PRGRUN  equ 144 ;application has been started (P1=result -> 0=ok, 1=file doesnt exist, 2=file is not executable, 3=error while loading  [P8=filemanager error code], 4=memory full, P8=app ID, P9=process ID)
.MSR_SYS_SYSFIL  equ 154 ;filemanager function returned (P1=number, P2-13=AF,BC,DE,HL,IX,IY)
.MSR_SYS_SYSWRN  equ 157 ;message/confirm window response (P1 -> 0=already in use, 1=opened [P2=number], 2=ok, 3=yes, 4=no, 5=cancel/close)
.MSR_SYS_PRGSRV  equ 158 ;shared service function response (P1=state [5=not found, other codes see MSR_SYS_PRGRUN], P8=app ID, P9=process ID)
.MSR_SYS_SELOPN  equ 159 ;message from fileselect dialogue (P1 -> 0=Ok, 1=cancel, 2=already in use, 3=no memory free, 4=no window free, -1=open ok, modal window has been opened [P2=number])

;Desktop Commands
.MSC_DSK_WINOPN  equ 32  ;open window (P1=ram bank, P2/3=address data record)
.MSC_DSK_WINMEN  equ 33  ;redraw menu bar (P1=window ID) [only if focus]
.MSC_DSK_WININH  equ 34  ;redraw window content (P1=window ID, P2=-1/-Num/Object, P3=Object) [only if focus]
.MSC_DSK_WINTOL  equ 35  ;redraw window toolbar (P1=window ID) [only if focus]
.MSC_DSK_WINTIT  equ 36  ;redraw window title (P1=window ID) [only if focus]
.MSC_DSK_WINSTA  equ 37  ;redraw window status lien (P1=window ID) [only if focus]
.MSC_DSK_WINMVX  equ 38  ;set content x offset (P1=window ID, P2/3=XPos) [only if focus]
.MSC_DSK_WINMVY  equ 39  ;set content y offset (P1=window ID, P2/3=XPos) [only if focus]
.MSC_DSK_WINTOP  equ 40  ;takes window to the front (P1=window ID) [always]
.MSC_DSK_WINMAX  equ 41  ;maximize window (P1=window ID) [always]
.MSC_DSK_WINMIN  equ 42  ;minimize window (P1=window ID) [always]
.MSC_DSK_WINMID  equ 43  ;restore window size (P1=window ID) [always]
.MSC_DSK_WINMOV  equ 44  ;moves window to a new position (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
.MSC_DSK_WINSIZ  equ 45  ;resize the window (P1=window ID, P2/3=XPos, P4/5=YPos) [always]
.MSC_DSK_WINCLS  equ 46  ;closes and removes window (P1=window ID) [always]
.MSC_DSK_WINDIN  equ 47  ;redraw window content, even if it hasnt focus (P1=window ID, P2=-1/-Num/Objekt, P3=Object) [always]
.MSC_DSK_DSKSRV  equ 48  ;desktop service request (P1=type, P2-P5=parameters)
.MSC_DSK_WINSLD  equ 49  ;redraw window scrollbars (P1=window ID) [only if focus]
.MSC_DSK_WINPIN  equ 50  ;redraw window content part (P1=window ID, P2=-1/-Num/Object, P3=Object, P4/5=Xbeg, P6/7=Ybeg, P8/9=Xlen, P10/11=Ylen) [always]
.MSC_DSK_WINSIN  equ 51  ;redraw content of a super control (P1=window ID, P2=super control ID, P3=SubObject) [always]
.MSC_DSK_MENCTX  equ 52  ;opens context menu (P1=ram bank, P2/3=address data record, P4/5=Xbeg [-1=mouse position], P6/7=Ybeg) ##!!## doc+lib
.MSC_DSK_STIADD  equ 53  ;adds systray-icon (P1=ram bank, P2/3=address, P4=ID)
.MSC_DSK_STIREM  equ 54  ;removes systray-icon (P1=number)
.MSC_DSK_STIUPD  equ 55  ;updates systray-icon (P1=number)

;Desktop Responses
.MSR_DSK_WOPNER  equ 160 ;open window failed; the maximum of 32 windows has been reached
.MSR_DSK_WOPNOK  equ 161 ;open window successfull (P4=number)
.MSR_DSK_WCLICK  equ 162 ;window has been clicked (P1=window number, P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)
.MSR_DSK_DSKSRV  equ 163 ;desktop service answer (P1=type, P2-P5=parameters)
.MSR_DSK_WFOCUS  equ 164 ;window got/lost focus (P1=window number, P2=type [0=blur, 1=focus])
.MSR_DSK_CFOCUS  equ 165 ;control focus changed (P1=window number, P2=control number, P3=reason [0=mouse click/wheel, 1=tab key])
.MSR_DSK_WRESIZ  equ 166 ;window has been resized (P1=window number)
.MSR_DSK_WSCROL  equ 167 ;window content has been scrolled (P1=window number)
.MSR_DSK_MENCTX  equ 168 ;menu has been clicked or canceld (P1=1 ok, P2/3=value, P4=type [0=normal, 1=check]) ##!!## doc+lib
.MSR_DSK_STIADD  equ 169 ;result of adding systray-icon (P1=1 ok, P2=number)
.MSR_DSK_STICLK  equ 170 ;systray-icon has been clicked (P1=ID)

.MSR_DSK_EXTDSK  equ 191 ;command for extended desktop (used internally; P1=command, P2-x=parameters)

.FNC_DXT_DSKBGR  equ 001 ;background has been updated
.FNC_DXT_FILRUN  equ 002 ;file has been opened via prgrun (P2/3=address, P4=bank)
.FNC_DXT_FILBRW  equ 003 ;file has been selected via file browser (P2/3=address, P4=bank)
.FNC_DXT_MENCLK  equ 004 ;startmenu has been clicked (P2/3=value)
.FNC_DXT_DSKCLK  equ 005 ;desktop window has been clicked (P2=action, P3=subspezification, P4/5,P6/7,P8/9=parameters)

;Shell Commands
.MSC_SHL_CHRINP  equ 64  ;char is requested (P1=channel [0=standard, 1=keyboard])
.MSC_SHL_STRINP  equ 65  ;line is requested (P1=channel [0=standard, 1=keyboard], P2=ram bank, P3/4=address)
.MSC_SHL_CHROUT  equ 66  ;char should be writtten (P1=channel [0=standard, 1=screen], P2=char)
.MSC_SHL_STROUT  equ 67  ;line should be writtten (P1=channel [0=standard, 1=screen], P2=ram bank, P3/4=address, P5=length)
.MSC_SHL_EXIT    equ 68  ;application released focus or quit itself (P1 -> 0=quit, 1=blur)
.MSC_SHL_PTHADD  equ 69  ;add additional path to current one (P1=base path, P3=addition path, P5=final path, P7=ram bank)

;Shell Responses
.MSR_SHL_CHRINP  equ 192 ;char has been received (P1=EOF-flag [0=no EOF], P2=char, P3=error status)
.MSR_SHL_STRINP  equ 193 ;line has been received (P1=EOF-flag [0=no EOF], P3=error status)
.MSR_SHL_CHROUT  equ 194 ;char has been written (P3=error status)
.MSR_SHL_STROUT  equ 195 ;line has been written (P3=error status)
.MSR_SHL_PTHADD  equ 197 ;path has been combined (P1=total end address, P3=directory end address, P5=flags)

;Screensaver Messages
.MSC_SAV_INIT    equ 1   ;initialises the screen saver (P1=bank of config data, P2/3=address of config data [64bytes])
.MSC_SAV_START   equ 2   ;start screen saver
.MSC_SAV_CONFIG  equ 3   ;open screen savers own config window (at the end the screen saver has to send the result back to the sender)
.MSR_SAV_CONFIG  equ 4   ;returns user adjusted screen saver config data (P1=bank of config data, P2/3=address of config data [64bytes])


;D E S K T O P - A C T I O N S
.DSK_ACT_CLOSE   equ 5   ;close button has been clicked or ALT+F4 has been pressed
.DSK_ACT_MENU    equ 6   ;menu entry has been clicked (P8/9=menu entry value)
.DSK_ACT_CONTENT equ 14  ;a control of the content has been clicked (P3=sub spec [see dsk_sub...], P4=key or P4/5=Xpos within the window, P6/7=Ypos, P8/9=control value)
.DSK_ACT_TOOLBAR equ 15  ;a control of the toolbar has been clicked (see DSK_ACT_CONTENT)
.DSK_ACT_KEY     equ 16  ;key has been pressed without touching/modifying a control (P4=Ascii Code)

.DSK_SUB_MLCLICK equ 0   ;left mouse button has been clicked
.DSK_SUB_MRCLICK equ 1   ;right mouse button has been clicked
.DSK_SUB_MDCLICK equ 2   ;double click with the left mouse button
.DSK_SUB_MMCLICK equ 3   ;middle mouse button has been clicked
.DSK_SUB_KEY     equ 7   ;keyboard has been clicked and did modify/click a control (P4=Ascii Code)
.DSK_SUB_MWHEEL  equ 8   ;mouse wheel has been moved (P4=Offset)


;D E S K T O P - S E R V I C E S
.DSK_SRV_MODGET  equ 1   ;get screen mode (output P2=mode, P3=virtual desktop)
.DSK_SRV_MODSET  equ 2   ;set screen mode (input P2=mode, P3=virtual desktop)
.DSK_SRV_COLGET  equ 3   ;get colour      (input P2=number, output P2=number, P3/4=RGB value)
.DSK_SRV_COLSET  equ 4   ;set colour      (input P2=number, P3/4=RGB value)
.DSK_SRV_DSKSTP  equ 5   ;freeze desktop  (input P2=type [0=Pen0, 1=Raster, 2=background, 255=no screen modification, switch off mouse])
.DSK_SRV_DSKCNT  equ 6   ;continue desktop
.DSK_SRV_DSKPNT  equ 7   ;clear desktop   (Eingabe P2=Typ [0=Pen0, 1=Raster, 2=background])
.DSK_SRV_DSKBGR  equ 8   ;initialize and redraw desktop background
.DSK_SRV_DSKPLT  equ 9   ;redraw the complete desktop
.DSK_SRV_DSKOPN  equ 11  ;open desktop background window


;C L I P B O A R D - T Y P E S
.CLPTYP_TEXT     equ 1   ;plain text
.CLPTYP_GRAPHIC  equ 2   ;graphic with extended header
.CLPTYP_ITEMS    equ 3   ;item list (*not defined yet*)
.CLPTYP_ICON     equ 4   ;desktop icon shortcut


;J U M P S
.jmp_memsum  equ #8100 ;MEMSUM
.jmp_sysinf  equ #8103 ;SYSINF
.jmp_clcnum  equ #8106 ;CLCNUM
.jmp_mtgcnt  equ #8109 ;MTGCNT
.jmp_timget  equ #810C ;TIMGET
.jmp_timset  equ #810F ;TIMSET
.jmp_memget  equ #8118 ;MEMGET
.jmp_memfre  equ #811B ;MEMFRE
.jmp_memsiz  equ #811E ;MEMSIZ
.jmp_meminf  equ #8121 ;MEMINF
.jmp_bnkrwd  equ #8124 ;BNKRWD
.jmp_bnkwwd  equ #8127 ;BNKWWD
.jmp_bnkrbt  equ #812A ;BNKRBT
.jmp_bnkwbt  equ #812D ;BNKWBT
.jmp_bnkcop  equ #8130 ;BNKCOP
.jmp_bnkget  equ #8133 ;BNKGET
                      ;**empty**
.jmp_scrget  equ #8139 ;SCRGET
.jmp_mosget  equ #813C ;MOSGET
.jmp_moskey  equ #813F ;MOSKEY
.jmp_bnk16c  equ #8142 ;BNK16C
.jmp_keytst  equ #8145 ;KEYTST
.jmp_keysta  equ #8148 ;KEYSTA
.jmp_keyput  equ #814B ;KEYPUT
.jmp_bufput  equ #814E ;BUFPUT
.jmp_bufget  equ #8151 ;BUFGET
.jmp_bufsta  equ #8154 ;BUFSTA
.jmp_iominp  equ #8157 ;IOMINP (cpc only)
.jmp_iomout  equ #815a ;IOMOUT (cpc only)

.jmp_bnkcll  equ #ff03 ;BNKCLL
.jmp_bnkret  equ #ff00 ;BNKRET


;Filemanager Functions (call via MSC_SYS_SYSFIL)
.FNC_FIL_STOINI  equ 000 ;Storage Init (Removes all mass storage devices)
.FNC_FIL_STONEW  equ 001 ;Storage New (Adds a new mass storage device)
.FNC_FIL_STORLD  equ 002 ;Storage Reload (Reloads a mass storage device, if its "removeable media" status is activated)
.FNC_FIL_STODEL  equ 003 ;Storage Delete (Removes an existing mass storage device)
.FNC_FIL_STOINP  equ 004 ;Storage ReadSector (Reads a sector from a mass storage device (no memory banking))
.FNC_FIL_STOOUT  equ 005 ;Storage WriteSector (Write a sector to a mass storage device (no memory banking))
.FNC_FIL_STOACT  equ 006 ;Storage Activate (Loads the format and the file system type of a mass storage device)
.FNC_FIL_STOINF  equ 007 ;Storage Information (Returns information about a mass storage device)
.FNC_FIL_STOTRN  equ 008 ;Storage DataTransfer (Reads or writes a number of sectors (512 bytes) from/to the mass storage device)

.FNC_FIL_DEVDIR  equ 013 ;
.FNC_FIL_DEVINI  equ 014 ;
.FNC_FIL_DEVSET  equ 015 ;

.FNC_FIL_FILINI  equ 016 ;File Init (Initialises the whole file manager)
.FNC_FIL_FILNEW  equ 017 ;File New (Creates a new file and opens it for read/write access)
.FNC_FIL_FILOPN  equ 018 ;File Open (Opens an existing file for read/write access)
.FNC_FIL_FILCLO  equ 019 ;File Close (Closes an opened file)
.FNC_FIL_FILINP  equ 020 ;File Input (Reads a specified amount of bytes out of an opened file)
.FNC_FIL_FILOUT  equ 021 ;File Output (Writes a specified amount of bytes into an opened file)
.FNC_FIL_FILPOI  equ 022 ;File Pointer (Moves the file pointer to another position)
.FNC_FIL_FILF2T  equ 023 ;File Decode Timestamp (Decodes the file timestamp, which is used for the file system)
.FNC_FIL_FILT2F  equ 024 ;File Encode Timestamp (Encodes the file timestamp, which is used for the file system)
.FNC_FIL_FILLIN  equ 025 ;File LineInput (Reads one text line out of an opened file)

.FNC_FIL_DIRDEV  equ 032 ;Directory Device (Selects the current drive)
.FNC_FIL_DIRPTH  equ 033 ;Directory Path (Selects the current path for the current or a different drive)
.FNC_FIL_DIRPRS  equ 034 ;Directory Property Set (Changes a property of a file or a directory)
.FNC_FIL_DIRPRR  equ 035 ;Directory Property Get (Reads a property of a file or a directory)
.FNC_FIL_DIRREN  equ 036 ;Directory Rename (Renames a file or a directory)
.FNC_FIL_DIRNEW  equ 037 ;Directory New (Creates a new directory)
.FNC_FIL_DIRINP  equ 038 ;Directory Input (Reads the content of a directory)
.FNC_FIL_DIRDEL  equ 039 ;Directory Delete (Deletes one or more files)
.FNC_FIL_DIRRMD  equ 040 ;Directory Delete Directory (Deletes a sub directory)
.FNC_FIL_DIRMOV  equ 041 ;Directory Move (Moves a file or sub directory into another directory of the same drive)
.FNC_FIL_DIRINF  equ 042 ;Directory Drive Information (Returns information about one drive)

;Network Daemon Functions
.FNC_NET_CFGGET  equ 001 ;config information
.FNC_NET_CFGSET  equ 002 ;config setting

.FNC_NET_TCPOPN  equ 016 ;TCP open
.FNC_NET_TCPCLO  equ 017 ;TCP close
.FNC_NET_TCPSTA  equ 018 ;TCP status
.FNC_NET_TCPRCV  equ 019 ;TCP receive
.FNC_NET_TCPSND  equ 020 ;TCP send
.FNC_NET_TCPSKP  equ 021 ;TCP skip received data
.FNC_NET_TCPFLS  equ 022 ;TCP flush send buffer
.FNC_NET_TCPDIS  equ 023 ;TCP disconnect
.MSR_NET_TCPEVT  equ 159 ;TCP event

.FNC_NET_UDPOPN  equ 032 ;UDP open
.FNC_NET_UDPCLO  equ 033 ;UDP close
.FNC_NET_UDPSTA  equ 034 ;UDP status
.FNC_NET_UDPRCV  equ 035 ;UDP receive
.FNC_NET_UDPSND  equ 036 ;UDP send
.FNC_NET_UDPSKP  equ 037 ;UDP skip received data
.MSR_NET_UDPEVT  equ 175 ;UDP event

.FNC_NET_DNSRSV  equ 112 ;DNS resolve
.FNC_NET_DNSVFY  equ 113 ;DNS verify

.PrgDatCod     equ 0	;Code Length including 256 Header
.PrgDatDat     equ 2	;Data Length to a maximum 16k
.PrgDatTra     equ 4   ;Transfer Part Length
.PrgDatOrg     equ 6   ;Original ORG
.PrgDatRel     equ 8   ;Number of Entries in Relocation Table
.PrgDatStk     equ 10  ;Stack Length at start of Transfer
.PrgDatCrn     equ 12	;Crunched Length
.PrgDatCtp     equ 14	;Crunch Typ
.PrgDatNam     equ 15	;Program Name (Always 32 Bytes)+0 33 Byte
.PrgDatIdn     equ 48  ;SymExe10
.PrgDatRes     equ 56  ;Reserve
.PrgDatIsm     equ 90  ;Small Ico
.PrgDatIbg     equ 109 ;Big Ico
.PrgDatLen     equ 256 ;

.PrgPstDat     equ 6   ;
.PrgPstTra     equ 8   ;
.PrgPstSpz     equ 10  ;
.PrgPstBnk     equ 14  ;
.PrgPstMem     equ 48  ;
.PrgPstNum     equ 88  ;
.PrgPstPrz     equ 89  ;


.ScanCode_E	equ 45
SYMBOS_ORG #100
;**** 256 Application Header ****
.AppCodBeg     dw  AppDatBeg-AppCodBeg      ;Length of Cod
               dw  AppTrnBeg-AppDatBeg      ;Length of Dat
               dw  AppTrnEnd-AppTrnBeg      ;Length of Transfe
.AppDatAdr     dw  #100                    ;Original Origi
.AppTrnAdr     dw  0                        ;Number of Entries In Relocation Tabl
.AppPrzLst     dw  AppStk-AppTrnBeg         ;Stack Lengt
               dw  0                        ;Length of Crunched Dat
.AppBnkNum     db  0                        ;Crunch Typ
.AppNam        db  "SymbOS Application      ",0
.AppIcon16     db  1
.AppIconOff    dw  Icon24_Data-AppCodBeg
.Appxxxx       db  0,0,0,0,0
.AppMemTab     db  "SymExe10"             ;File Check
.AppExtCode    dw  0
.AddExtData    dw  8192 
.AddExtTrans   dw  4096
               ds  28
.AppIcnSml    
.AppStartForm  equ 0
        db 2,8,8
      db     15,15,14,3,13,13,73,73,73,73,75,75,60,135,15,15
.AppIcnBig    
.AppIcnLrg       db 6,24,24
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

;***************
;**** Code *****
;***************
.AppWin     db   0
.DskPrzN    db   2
.SysPrzN    db   3
.WinDatPrz  equ  3

.V_App_In_Use			db 	0

.AppPrz:
;**** Open Primary Window ****
		;ld		hl,Quig_String_End_Text
		;ld		de,4
		;add		hl,de
		;ld		(Quig_String_Pos),hl
		ld		hl,AppTrnEnd+260
		ld		a,h
		ld		(Quig_String_AS_HByte),a		;Set Byte so we can check if string is in String area or String buffer
		;ld		(Quig_String_Buffer_Stack),hl
		;ld		(Quig_String_Buffer_Pos),hl



		;ld		hl,AppTrnEnd+260
		;ld		a,h
		;ld		(Quig_String_AS_HByte),a		;Set Byte so we can check if string is in String area or String buffer
		;ld		(Quig_String_Buffer_Stack),hl
		;ld		(Quig_String_Buffer_Pos),hl
		;call	Quig_Init_Memory_Stuff
		ld		a,AppStartForm					;**** Form to Open first
		ld		l,a
		call	Quig_Form_Open					;**** Form Opener
;****************************************
;**** Main Application Control Loop *****
;****************************************
.Quig_Control_Loop:
		ld		a,(V_App_In_Use)
		And		a
		jr		nz,Quig_Control_Loop_1
		rst		#30								;Wait for message
		ld		a,(AppPrzN)		
       	db		#dd:ld l,a
		db		#dd:ld h,-1
 		ld		iy,AppMsgB
		rst		#18
		db		#dd:dec l						;AppMsgB should be populated
		jr		nz,Quig_Control_Loop_2			;No Message so just run Main()code.	
		ld		a,(Quig_Net_Process)			;Get Process number (Default 255 until set)
		cp		255							
		jr		z,Quig_Control_Loop_99			;=255 Net not initialized so skip
		db 		#dd:cp h
		jp		z,Quig_Net_Event				;IXH = Process number so must be Net Event
.Quig_Control_Loop_99:		
		ld		a,(AppMsgB+0)					
		or		a
		jp		z,Quig_End
		scf
		cp		MSR_DSK_WCLICK					;**** Click on a Control
		jp		z,Quig_Control_Event
		cp		MSR_DSK_WRESIZ					;**** Resize window ?
		jp		z,Quig_Form_Event_Resize
		cp		MSR_DSK_WSCROL					;**** Scrolled Form ?
		jp		z,Quig_Form_Event_Scroll		
		cp		MSR_DSK_CFOCUS					;**** Focus change ?
		jp		z,Quig_Form_Event_Focus		
.Quig_Control_Loop_2:
		call	qfunc_main
.Quig_Control_Loop_1:
		Xor		a
		ld		(V_App_In_Use),a
		jp		Quig_Control_Loop
		
;**** NET EVENTS		
.Quig_Net_Event:
		INCLIB   QUIG.NET.TCP.FIND.FREE.HANDLE
		INCLIB   QUIG.NET.TCP.SOCKET.COUNT
        call 	snwmsgo_afbcdehlixiy
		ld		(Quig_Event_Net_Handle),a
		ld		a,l
		ld		(Quig_Event_Net),a
		ld		(Quig_Net_Received_Value),bc
		
		ld		a,(Quig_Event_Net)
		cp		2					;tcpestablished
		jp		z,Quig_Found_TCP_Establish
		cp		128
		jp		z,Quig_Found_Data_Received

		jp		Quig_Control_Loop_2

.Quig_Found_Data_Received:
		jp		Quig_Net_Event6
		
.Quig_Found_TCP_Establish:
		;**** Connection established ****
		;**** Store the recieved Handle into Recieve 2nd byte of the Handle List
		call	Quig_Net_TCP_Find_Free_Handle
		ld		a,(Quig_Event_Net_Handle)
		ld		(hl),a
		jp		Quig_Net_Event6
		
		;**** Is this a server
		ld		a,(Quig_Net_TCP_Server)		
		and		a
		jr		z,Quig_Net_Event6
		;**** It is the server
		call	Quig_Net_TCP_Socket_Count
		ld		a,(Quig_Net_TCP_Socket_Max)
		cp		l
		jr		z,Quig_Net_Event6				;Connections => Max connections so dont open new listener
		jr		c,Quig_Net_Event6				;Connections => Max connections so dont open new listener	
		ld		hl,(Quig_Net_TCP_Server_Port)
		;**** Open a new listener
		ld		a,1		
        call 	snwmsgi_afbcdehlixiy
        db 		FNC_NET_TCPOPN
        call	snwmsgo_afhl
		ld		(Quig_Net_Handle),a	

.Quig_Net_Event6:		
		call 	QFunc_Net_Event	
.Quig_Net_Event7:
		jp		Quig_Control_Loop_2
		
.Quig_Net_Error:			dw	0
.Quig_Net_Handle:			db	255
.Quig_Net_Process:			db	255

.Quig_Net_TCP_Server:		db	0
.Quig_Net_TCP_Server_Port:	dw	0
.Quig_Net_TCP_Socket:		db 	0
.Quig_Net_TCP_Socket_Max:	db 	0

.Quig_Net_Received_Value:	dw	0
.Quig_Net_Transfered_Value:	dw 	0
.Quig_Net_Send_Wait_Value:	dw 	0

.Quig_Event_Net:			db	0
.Quig_Event_Net_Handle:		db	255

.Quig_Net_Handle_Free:		dw	0		;Holds the last Free Handle found
.Quig_Net_Handle_List:		db 	255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255

		
;**** Redirect a Clicked on Control Event		
.Quig_Control_Event:
		ld		a,1
		ld		(V_App_In_Use),a
		ld		a,(Event_Type)	 		
 		cp		DSK_ACT_CONTENT
 		jp		z,Quig_Content
 		cp		DSK_ACT_TOOLBAR
 		jp		z,Quig_Tool		
		cp		DSK_ACT_CLOSE
		jp		z,Quig_End
		cp		DSK_ACT_MENU
 		jp		z,Quig_Menu
		cp		DSK_ACT_KEY
		jp		z,Quig_Key		
		jp		Quig_Control_Loop_1
		
;**** Form Event ****
.Quig_Form_Event_Focus
		ld		a,5
		jr		Quig_Form_Event_X	
.Quig_Form_Event_Scroll
		ld		a,4
		jr		Quig_Form_Event_X	
.Quig_Form_Event_Resize
		ld		a,3
.Quig_Form_Event_X:		
		ld		(Quig_Form_Event_X_1+1),a
		call	Quig_FormSearch
		ld		a,e
.Quig_Form_Event_X_1
		ld		c,0								;**** C = 3/4 etc
		call	SyB_Call_Form_Event
		jp		Quig_Control_Loop_1
		
;*********************
;**** Key Control ****
;*********************
.Quig_Key:
		ld		a,(AppMsgB+4)
		and		%10000000
		jp		z,Quig_Content
		jp		Quig_Control_Loop_1

;**********************
;**** Menu Control ****
;**********************
.Quig_Menu:
		ld		a,1
		ld		(V_App_In_Use),a
		ld		hl,(AppMsgB+8)
		Xor		a
		cp		h
		jr		nz,Quig_Call_Set12
		cp		l
		jp		z,Quig_Control_Loop_1
.Quig_Call_Set12
		Xor		a
		ld		(V_App_In_Use),a
		push	ix
		push	iy
		ld		(Quig_Call_Set2+1),hl
.Quig_Call_Set2:
		call	0
		pop		iy
		pop		ix		
		jp		Quig_Control_Loop_1

		
;****************************************
;**** User has clicked on one Tool Control ****
;****************************************		
.Quig_Tool:
		ld		hl,ControWindowDataList+2
		Jr		Quig_Content2
;**** User has clicked on one Control ****
.Quig_Content:
		ld		hl,ControWindowDataList
.Quig_Content2:
		push	hl
		call	Quig_FormSearch
		ld		l,e
		ld		h,0
		add		hl,hl
		add		hl,hl	
		pop		de
		add		hl,de
	
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		ld		a,(Event_Control_ID)
		ld		l,a
		ld		h,0
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,hl
		add		hl,de
		inc		hl
		inc		hl
		ld		a,(hl)
		cp		43				;CHeck for List Sort
		jp		nz,Quig_Content3
;Do list sort whatever		
		push	hl
		inc		hl
		inc		hl				;Not at ExtData
		ld		a,(hl)
		inc		hl
		ld		h,(hl)
		ld		l,a				;HL=Address of Extended List data
		
		ld		c,(hl)			;BC=Lines
		inc		hl
;		ld		b,(hl)
		inc		hl
		inc		hl
		inc		hl
		ld		e,(hl)			;DE=Location of Data
		inc		hl
		ld		d,(hl)
		inc		hl
		inc		hl
		inc		hl
		ld		b,(hl)			;Number of columns
		ex		de,hl
		;So HL=Addr data;BC Lines
.Quig_List_Stuff_Loop1		
		ld		a,c
		and		a
		jr		z,Quig_List_Stuff_Exit
		dec		c
		inc		hl
		inc		hl
		ld		a,b
.Quig_List_Stuff_Loop2		
		ld		e,(hl)
		inc		hl
		push	hl
		ld		d,(hl)
		dec		hl			;HL=Start of data again
		ex		de,hl
		
		dec		hl
		dec		hl
		dec		hl
		ld		(hl),d
		dec		hl
		ld		(hl),e
		
		pop		hl
		inc		hl
		dec		a
		jr		nz,Quig_List_Stuff_Loop2
		
		jr		Quig_List_Stuff_Loop1
		
.Quig_List_Stuff_Exit		
		pop		hl
.Quig_Content3:		
		ld		de,12
		add		hl,de
		ld		e,(hl)
		inc 	hl
		ld		d,(hl)
		Xor		a
		cp		e
		jp		nz,Quig_Content_Event_1
		cp		d
		jp		nz,Quig_Content_Event_1
		jp		Quig_Control_Loop
.Quig_Content_Event_1:
		Xor		a
		ld		(V_App_In_Use),a
		ld		(Quig_Content_Event_2+1),de
.Quig_Content_Event_2
		call	0		
		jp		Quig_Control_Loop_1	

;****                       ****		
;**** Shut down Application ****
;****                       ****		
.Quig_End:
		call	Quig_FormSearch
		ld		l,e
		call	Quig_Form_Close
		ld		a,(Quig_Form_No)
		and		a
		jp		z,Quig_End_X
		jp		Quig_Control_Loop_1
.Quig_End_X:		
		ld		a,(AppPrzN)
		db		#dd:ld l,a
		ld		a,(SysPrzN)
		db		#dd:ld h,a
		ld		a,(AppCodBeg+PrgPstNum)
		ld		h,a
		ld		l,MSC_SYS_PRGEND
		ld		(AppMsgB),hl
		ld		iy,AppMsgB
		rst		#10
.Quig_End_1
 		rst		#30
		jr		Quig_End_1
	
;****                  ****
;**** HL = Form Number
;****                  ****
.Quig_Form_Open:
		ld		a,l
		call 	Quig_Form_Return
		cp		255								;
		ret		nz								;**** If not clear then Return 
		push	hl
		ld		a,(Quig_Form_No)				;**** A = SymStudio Window Number			
		ld		c,0								;**** C = 0 = Get data Begin Address
		call	Quig_GetWindowEventAddr			;**** Get Address of Window Data
		ld		e,(hl)
		inc		hl
		ld		d,(hl)							;**** DE = Address of Window Data
		ld		a,(AppBnkNum)
		inclib 	SYDESKTOP.WINOPN
		call	SyDesktop_WINOPN
		pop		hl
		ret		c								;**** If Carry then hasn't Opened window
		ld		(hl),a							;**** Store Inetrnal number into form list
		ld		a,(Quig_Form_No)				;**** A = SymStudio Window Number
		ld		c,1								;**** C = 1 = Get Open Address
		call	SyB_Call_Form_Event
		Xor		a		
		ret
;****              ****		
;**** Close a Form ****
;****              ****
.Quig_Form_Close:	
		ld		a,l
		call	Quig_Form_Return
		cp		255
		ret		z
		push	hl
		ld 		c,MSC_DSK_WINCLS
        call 	SyDesktop_SendMessage
		pop		hl
		ld		a,255
		ld		(hl),a		
		ld		a,(Quig_Form_No)				;**** A = SymStudio Window Number
		ld		c,2								;**** C = 2 = Get Close Address
		call	SyB_Call_Form_Event
		ret

;**** Get a Internal Window number in a
;IN A = Window
;OUT A = Symbos Window number or #ff
;    HL =  address of Internal window stoe
.Quig_Form_Return
		ld		(Quig_Form_No),a				;**** Store the number of the Internal Window
		ld		hl,Quig_FormIDs					;**** Point to Start of Window List
		ld		e,a								;**** DE = A
		ld		d,0
		add		hl,de							;**** Calc Position
		ld		a,(hl)							;**** Checks if exists
		ret
;****                       ****
;**** Check If Event and Do ****
;****                       ****
;A=Form No C=Event To search
.SyB_Call_Form_Event:
		call	Quig_GetWindowEventAddr
		Xor		a
		ld		e,(hl)
		inc		hl
		ld		d,(hl)
		cp		e		
		jr		nz,SyB_Call_Form_Event_2	
		cp		d
		ret		z
.SyB_Call_Form_Event_2	
		ld		(SyB_Call_Form_Event_3+1),de
.SyB_Call_Form_Event_3
		call	0
		ret	
		
;****                                 ****
;**** Get User Form No fro OS Form No ****
;****                                 ****
.Quig_FormSearch:
		ld		a,(Event_Form_ID)
		ld		b,8
		ld		e,0
		ld		hl,Quig_FormIDs	
.Quig_FormSearch_1	
		cp		(hl)
		ret		z
		inc		e
		inc		hl
		djnz	Quig_FormSearch_1
		ret		

;******************************************************************************
;*** Name           System_CallFunction
;*** Input          ((SP+0)) = System manager command
;***                ((SP+1)) = Function ID
;***                AF,BC,DE,HL,IX,IY = Input for the function
;*** Output         AF,BC,DE,HL,IX,IY = Output from the function
;*** Destroyed      -
;*** Description    Calls a function via the system manager. This function is
;***                needed to have access to the file manager.
;******************************************************************************
.SySystem_CallFunction
		ld (AppMsgB+04),bc      ;copy registers into the message buffer
        ld (AppMsgB+06),de
        ld (AppMsgB+08),hl
        ld (AppMsgB+10),ix
        ld (AppMsgB+12),iy
        push af
        pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (AppMsgB+00),de      ;module und funktion number
        ld a,e
        ld (SyCallN),a
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #10                 ;send message
.SyCall1 rst #30
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #18                 ;wait for answer
        db #dd:dec l
        jr nz,SyCall1
        ld a,(AppMsgB)
        sub 128
        ld e,a
        ld a,(SyCallN)
        cp e
        jr nz,SyCall1
        ld hl,(AppMsgB+02)      ;get registers out of the message buffer
        push hl
        pop af
        ld bc,(AppMsgB+04)
        ld de,(AppMsgB+06)
        ld hl,(AppMsgB+08)
        ld ix,(AppMsgB+10)
        ld iy,(AppMsgB+12)
        ret
.SyCallN db 0		
		
;**** A = Window 0-7
;**** C = 0 = Data Begin Address
;****     1 = Open Event Address
;****     2 = Close Event Address
;****     3 = Resize Event Address
;****     4 = Main Loop Address
.Quig_GetWindowEventAddr
		add		a				;Times 2
		add		a				;Times 4
		add		a				;Times 8
		add		c				;Event
		add		a				;Times 16 + (Event*2)
		ld		hl,App_Form_List
		ld		e,a
		ld		d,0
		add		hl,de
		ret

.Quig_Form_No:				db	0
.Quig_FormIDs:				db  255,255,255,255,255,255,255,255

;.StringMemoryLoc:			dw	0

.Quig_Directory_Error_Byte:		db	0
.Quig_File_Select_Ext   		equ AppTrnEnd
.Quig_File_Select_File  		equ AppTrnEnd+4
.Quig_String_Buffer_Area_Start 	equ AppTrnEnd+260
.Quig_String_Buffer_StackNo:	dw 0
.Quig_String_Buffer_Pos:		dw AppTrnEnd+260
.Quig_String_Buffer_Stack:		dw AppTrnEnd+260,0,0,0,0,0,0,0,0,0
.Quig_String_AS_HByte:			db 0
.Quig_String_Pos:				dw Quig_String_End_Text+4
;.Quig_Init_Memory_Stuff:
;		ld		hl,Quig_String_End_Text
;		ld		de,4
;		add		hl,de
;		ld		(Quig_String_Pos),hl
;		ld		hl,Quig_String_Buffer_Area_Start
;		ld		a,h
;		ld		(Quig_String_AS_HByte),a		;Set Byte so we can check if string is in String area or String buffer
;		ld		(Quig_String_Buffer_Stack),hl
;		ld		(Quig_String_Buffer_Pos),hl
;		ret
;
		
.ErrorNum:					dw	0
.ErrorPC:					dw	0
.False:						db	0
.True:						db	1
.tcounter					dw	0





;### SUB ROUTINES #############################################################
.snwmsgi_afbcdehlixiy
        ld (AppMsgB+10),ix   ;store registers to message buffer
        ld (AppMsgB+12),iy
.snwmsgi_afbcdehl
        ld (AppMsgB+04),bc
.snwmsgi_afdehl
        ld (AppMsgB+06),de
.snwmsgi_afhl
        ld (AppMsgB+08),hl
.snwmsgi_af
        push af:pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld a,(hl)               ;set command
        inc hl
        push hl
        ld (AppMsgB+0),a
        ld (snwmsg2+1),a
        ld iy,AppMsgB
        ld a,(AppPrzN)	;ld a,(App_PrcID)
        db #dd:ld l,a
        ld a,(Quig_Net_Process)
        db #dd:ld h,a
        ld (snwmsg1+2),ix
        rst #10                 ;send message
.snwmsg1 ld ix,0                 ;wait for response
        rst #08
        db #dd:dec l
        jr nz,snwmsg1
        ld a,(AppMsgB)
        sub 128
.snwmsg2 cp 0
        ret z
        ld	a,(AppPrzN)			;ld a,(App_PrcID)        ;wrong response code -> re-send and wait for correct one
        db #dd:ld h,a
        ld a,(Quig_Net_Process)
        db #dd:ld l,a
        rst #10
        rst #30
        jr snwmsg1
.snwmsgo_afbcdehlixiy
        ld ix,(AppMsgB+10)   ;get registers from the message buffer
        ld iy,(AppMsgB+12)
        ld de,(AppMsgB+06)
.snwmsgo_afbchl
        ld bc,(AppMsgB+04)
.snwmsgo_afhl
        ld hl,(AppMsgB+02)
        push hl
        pop af
        ld hl,(AppMsgB+08)
        ret
	
	
QUIGLINE 1

QUIGLINE 2
// Quigs 1.01 Application for Symbos
QUIGLINE 3
// Name:
QUIGLINE 4
// Coder:
QUIGLINE 5
// Date / Version:
QUIGLINE 6

QUIGLINE 7
// Declare variables
QUIGLINE 8

QUIGLINE 9
Var a:Int
QUIGLINE 10
Var Tinker:String
QUIGLINE 11
Var Socks(10):Int
QUIGLINE 12
// End declares
QUIGLINE 13

QUIGLINE 14

QUIGLINE 15
Function Main:Void()
QUIGLINE 16
	// Main loop
QUIGLINE 17
	
QUIGLINE 18
EndF
QUIGLINE 19

QUIGLINE 20
Function Net.Event:Void()
QUIGLINE 21
	// Net Event
QUIGLINE 22
	If Event.Net.Received=1 Then
QUIGLINE 23
		
QUIGLINE 24
		label1.Text.Set  (label1.Text.Get +Event.Net.Receive.String)
QUIGLINE 25
		label1.Refresh
QUIGLINE 26
	EndIf
QUIGLINE 27
	If Event.Net.TCP.Establish=1 Then
QUIGLINE 28
		Tinker="*"+TextLine1.Text.Get+"*"
QUIGLINE 29
		a=a+1
QUIGLINE 30
		Socks(a)=Event.Net.Socket
QUIGLINE 31
		Net.TCP.Send Socks(a),Tinker
QUIGLINE 32
		Label2.Text.Set "Sent:"+Tinker
QUIGLINE 33
		Label2.Refresh
QUIGLINE 34
	EndIf
QUIGLINE 35
EndF
QUIGLINE 36

QUIGLINE 37
Function Form1.Open.Event:Void()
QUIGLINE 38
	a=Execute("c:\symbos\netd-loc.exe")
QUIGLINE 39
EndF
QUIGLINE 40
Function Connect.Event:Void()
QUIGLINE 41
	// generated on entry:
QUIGLINE 42
	//     = Event.Form()        ;Form number of resize event
QUIGLINE 43
	//     = Event.Type()        ;Symbos event number should be 162
QUIGLINE 44
	//     = Event.MouseX() & Event.MouseY()    ;Position of Mouse on event
QUIGLINE 45
	//     =
QUIGLINE 46
	Net.Initialise
QUIGLINE 47
	If Net.Initialised<>255 Then
QUIGLINE 48
		If Check1.Ticked Then
QUIGLINE 49
			Net.TCP.Server.Open 800,8
QUIGLINE 50
		Else
QUIGLINE 51
			Net.TCP.Client.Open "127.0.0.0",800
QUIGLINE 52
		EndIf
QUIGLINE 53
	EndIf
QUIGLINE 54
EndF
QUIGLINE 55

QUIGLINE 56
Function Send.Event:Void()
QUIGLINE 57
	// generated on entry:
QUIGLINE 58
	//     = Event.Form()        ;Form number of resize event
QUIGLINE 59
	//     = Event.Type()        ;Symbos event number should be 162
QUIGLINE 60
	//     = Event.MouseX() & Event.MouseY()    ;Position of Mouse on event
QUIGLINE 61
	//     =
QUIGLINE 62
	
QUIGLINE 63
	If a>0 Then
QUIGLINE 64
		Tinker="*"+TextLine1.Text.Get+"*"
QUIGLINE 65
		Net.TCP.Send Socks(1),Tinker
QUIGLINE 66
		Label2.Text.Set "Sent:"+Tinker
QUIGLINE 67
		Label2.Refresh
QUIGLINE 68
	EndIf
QUIGLINE 69
	
QUIGLINE 70
EndF
QUIGLINE 71
Function Send2.Event:Void()
QUIGLINE 72
	// generated on entry:
QUIGLINE 73
	//     = Event.Form()        ;Form number of resize event
QUIGLINE 74
	//     = Event.Type()        ;Symbos event number should be 162
QUIGLINE 75
	//     = Event.MouseX() & Event.MouseY()    ;Position of Mouse on event
QUIGLINE 76
	//     =
QUIGLINE 77
	If a>0 Then
QUIGLINE 78
		Tinker="*"+TextLine1.Text.Get+"*"
QUIGLINE 79
		Net.TCP.Send Socks(2),Tinker
QUIGLINE 80
		Label2.Text.Set "Sent:"+Tinker
QUIGLINE 81
		Label2.Refresh
QUIGLINE 82
	EndIf
QUIGLINE 83
	
QUIGLINE 84
EndF



    ASM
;**** Core End
.Quig_CodeEnd:db 0
;**********************
;**** Data Section ****
;**********************
.AppDatBeg
.AppFormStart:    dw Form1_Begin
.AppFormLists
    dw Form1_ControlWindowData
;**** Form Icon Data ***
;**** Define User Graphics ****
.Icon24_Data
.Icon24_Data_WidthByte:     db 12
.Icon24_Data_WidthPixel:    db 24
.Icon24_Data_Height:        db 24
.Icon24_Data_DataAddr:      dw Icon24_Data_Data
.Icon24_Data_EncodeAddr:    dw Icon24_Data_Encode
.Icon24_Data_Size:          dw 288
.Icon24_Data_Encode:        db 5
.Icon24_Data_Data:          
             db 51,51,51,51,51,51,51,51,51,51,51,51
             db 48,0,0,0,0,0,0,0,0,0,0,3
             db 48,0,0,0,0,1,17,16,0,0,0,3
             db 48,0,0,1,17,18,34,33,16,0,0,3
             db 48,0,0,18,34,34,34,34,33,16,0,3
             db 48,0,1,34,34,34,34,34,34,33,0,3
             db 48,0,18,34,34,33,18,34,34,33,0,3
             db 48,0,18,34,34,16,1,34,34,33,0,3
             db 48,1,34,34,33,0,0,18,34,33,0,3
             db 48,1,34,34,33,0,0,18,34,33,0,3
             db 48,1,34,34,33,0,0,18,34,33,0,3
             db 48,1,34,34,33,0,1,34,34,16,0,3
             db 48,1,34,34,34,17,18,34,34,16,0,3
             db 48,1,34,34,34,34,34,34,33,0,0,3
             db 48,0,18,34,34,34,34,34,17,0,0,3
             db 48,0,1,34,34,34,34,33,0,0,0,3
             db 48,0,0,17,17,34,34,34,16,0,0,3
             db 48,0,0,0,0,18,34,34,33,17,16,3
             db 48,0,0,0,0,1,34,34,34,34,16,3
             db 48,0,0,0,0,0,18,34,34,34,16,3
             db 48,0,0,0,0,0,1,34,34,34,16,3
             db 48,0,0,0,0,0,0,17,17,17,16,3
             db 48,0,0,0,0,0,0,0,0,0,0,3
             db 51,51,51,51,51,51,51,51,51,51,51,51
.Sheet_Data4:                   
.Sheet_Data4_WidthByte:     db 2
.Sheet_Data4_WidthPixel:    db 1
.Sheet_Data4_Height:        db 1
.Sheet_Data4_DataAddr:      dw Sheet_Data4_Data
.Sheet_Data4_EncodeAddr:    dw Sheet_Data4_Encode
.Sheet_Data4_Size:          dw 1
.Sheet_Data4_Encode:        db 0
.Sheet_Data4_Data:          dw 0
;**** Define User Variables ****
.File_Select_Text:   dw File_Select_Text_Data+4
.Directory_Select_Text:   dw Directory_Select_Text_Data+4
.var_wrd_a:   dw 0
.var_str_Tinker:   dw var_str_Tinker_Data+4
.ar1_wrd_Socks:   dw 0
         dw 0
         dw 0
         dw 0
         dw 0
         dw 0
         dw 0
         dw 0
         dw 0
         dw 0
         dw 0
;Spongebob
;**** String Data ***
.File_Select_Text_Data:         dw File_Select_Text:dw 1:db 0
.Directory_Select_Text_Data:    dw Directory_Select_Text:dw 1:db 0
.var_str_Tinker_Data:           dw var_str_Tinker:dw 1:db 0
.Quig_Dialog_1_Data:            dw Quig_Dialog_1:dw 1:db 0
.Quig_Dialog_2_Data:            dw Quig_Dialog_2:dw 1:db 0
.Quig_Dialog_3_Data:            dw Quig_Dialog_3:dw 1:db 0
.Form1_Text_Data:               dw Form1_Text:dw 7:db "Form 1",0
.Form1_Status_Text_Data:        dw Form1_Status_Text:dw 1:db 0
.Button1_Text_Data:             dw Button1_Text:dw 8:db "Connect",0
.Label2_Text_Data:              dw Label2_Text:dw 7:db "Label2",0
.Check1_Text_Data:              dw Check1_Text:dw 7:db "Server",0
.Send_Text_Data:                dw Send_Text:dw 5:db "Send",0
.Send2_Text_Data:               dw Send2_Text:dw 6:db "Send2",0
.Quig_String_End_Text:   db  0,0,0,0,0


;**************************
;**** Transfer Section ****
;**************************
.AppTrnBeg
          ds    128
.AppStk   ds    6*2
          dw    AppPrz
.AppPrzN  db    0
.AppMsgB
.Event_Message       db 0         ;0 Message No 16
.Event_Form_ID       db 0         ;1 Event happned on which Form
.Event_Type          db 0         ;2 Type of Event
.Event_UserInput     db 0         ;3 Key or Mouse Event
.Event_Key_ASCII                  ; Key ASCII - Shared Byte with next
.Event_MouseX        dw 0         ;4 MouseX when event happens
.Event_MouseY        dw 0         ;6 MouseY when event happens
.Event_Control_ID    dw 0         ;8 Control ID No
.Event_8             db 0         ;10
.Event_9             db 0         ;11
.Event_10            db 0         ;12
.Event_11            db 0         ;13
.Quig_Machine_Type   db 0    ;0=464, 1=664, 2=6128, 3=464Plus, 4=6128Plus 7=Enterprise 64/128 8=MSX2, 9=MSX2+, 10=MSX TurboR 12=PCW8xxx, 13=PCW9xxx
.Quig_Null_String    db 0
;**** Dialog Transfer ****
.Quig_Dialog_1:      dw Quig_Dialog_1_Data+4,6
.Quig_Dialog_2:      dw Quig_Dialog_2_Data+4,6
.Quig_Dialog_3:      dw Quig_Dialog_3_Data+4,6
.Quig_Dialog_4:      dw AppIcnLrg
.App_Form_List
       dw  Form1_Begin,QFunc_Form1_Open_Event,0,0,0,0,0,0
.ControWindowDataList
     dw Form1_ControlWindowData
     dw 0 ;**** There is No Toolbar
;***
;**** Z80 version of Form Form1 ***
;***
.Form1
.Form1_Addr:                    db 0,0
.Form1_Begin:                   
.Form1_Status:                  db 1
.Form1_Display:                 db 20
.Form1_SizeAdjust:              db 20
.Form1_OwnerID:                 db 0
.Form1_Left:                    dw 8
.Form1_Top:                     dw 14
.Form1_Width:                   dw 203
.Form1_Height:                  dw 178
.Form1_OffsetWidth:             dw 1
.Form1_OffsetHeight:            dw 8
.Form1_ContentWidth:            dw 194
.Form1_ContentHeight:           dw 178
.Form1_MinWidth:                dw 0
.Form1_MinHeight:               dw 0
.Form1_MaxWidth:                dw 1024
.Form1_MaxHeight:               dw 212
.Form1_IconAddr:                dw 0
.Form1_Text:                    dw Form1_Text_Data+4
.Form1_Status_Text:             dw Form1_Status_Text_Data+4
.Form1_MenuAddr:                dw Form1_Menu
.Form1_ControlWindowAddr:       dw Form1_ControlWindow
.Form1_ControlToolAddr:         dw 0;Form1_ControlTool
.Form1_ToolBarHeight:           dw 0;
     db 0,0,0,0,0,0,0,0,0       ;Symbos Reserved
.Form1_SuperWindow:             db  2
     ds 140,0                   ;Symbos Reserved
.Form1_Menu:                    
        dw  0

;****
;**** Data Control Record (ControlWindow) ****
;****
.Form1_ControlWindow:           
.Form1_ControlWindowCount:      db 8
.Form1_ControlWindowOwnerID:    db 0
.Form1_ControlWindowDataAddr:   dw Form1_ControlWindowData
.Form1_ControlWindowCalcAddr:   dw 0; Form1_ControlWindowCalc
     db 0,0,0,0,0,0,0,0
.Form1_ControlWindowFocus:      db 0
     db 0
;****
.Form1_ControlWindowData:       
;**** Object Window Background Data Record ****
dw 0,255*256+0,2,  0,0,1000,1000,0
;**** Object (Button1) Data Record ****
.Button1_Display      Equ 1
.Button1
.Button1_ID:                    dw 1
.Button1_Type:                  db 16   ;*Button
.Button1_ExtDataBank:           db 255
.Button1_Text:                  dw Button1_Text_Data+4
.Button1_Left:                  dw 6
.Button1_Top:                   dw 3
.Button1_Width:                 dw 40
.Button1_Height:                dw 11
.Button1_Code:                  dw QFunc_Connect_Event
;**** Object (Label2) Data Record ****
.Label2_Display      Equ 2
.Label2
.Label2_ID:                     dw 2
.Label2_Type:                   db 1   ;*Label
.Label2_ExtDataBank:            db 255
.Label2_ExtDataAddr:            dw Label2_ExtData
.Label2_Left:                   dw 7
.Label2_Top:                    dw 43
.Label2_Width:                  dw 135
.Label2_Height:                 dw 8
.Label2_Code:                   dw 0
;**** Object (Check1) Data Record ****
.Check1_Display      Equ 3
.Check1
.Check1_ID:                     dw 3
.Check1_Type:                   db 17   ;*Check
.Check1_ExtDataBank:            db 255
.Check1_ExtDataAddr:            dw Check1_ExtData
.Check1_Left:                   dw 53
.Check1_Top:                    dw 5
.Check1_Width:                  dw 50
.Check1_Height:                 dw 8
.Check1_Code:                   dw 0
;**** Object (Send) Data Record ****
.Send_Display      Equ 4
.Send
.Send_ID:                       dw 4
.Send_Type:                     db 16   ;*Button
.Send_ExtDataBank:              db 255
.Send_Text:                     dw Send_Text_Data+4
.Send_Left:                     dw 104
.Send_Top:                      dw 3
.Send_Width:                    dw 42
.Send_Height:                   dw 11
.Send_Code:                     dw QFunc_Send_Event
;**** Object (Send2) Data Record ****
.Send2_Display      Equ 5
.Send2
.Send2_ID:                      dw 5
.Send2_Type:                    db 16   ;*Button
.Send2_ExtDataBank:             db 255
.Send2_Text:                    dw Send2_Text_Data+4
.Send2_Left:                    dw 104
.Send2_Top:                     dw 17
.Send2_Width:                   dw 42
.Send2_Height:                  dw 11
.Send2_Code:                    dw QFunc_Send2_Event
;**** Object (TextLine1) Data Record ****
.TextLine1_Display      Equ 6
.TextLine1
.TextLine1_ID:                  dw 6
.TextLine1_Type:                db 32   ;*TextLine
.TextLine1_ExtDataBank:         db 255
.TextLine1_ExtDataAddr:         dw TextLine1_ExtData
.TextLine1_Left:                dw 6
.TextLine1_Top:                 dw 17
.TextLine1_Width:               dw 50
.TextLine1_Height:              dw 12 ; TextLine always set to 1
.TextLine1_Code:                dw 0
;**** Object (label1) Data Record ****
.label1_Display      Equ 7
.label1
.label1_ID:                     dw 7
.label1_Type:                   db 33   ;*TextBox
.label1_ExtDataBank:            db 255
.label1_ExtDataAddr:            dw label1_ExtData
.label1_Left:                   dw 7
.label1_Top:                    dw 60
.label1_Width:                  dw 189
.label1_Height:                 dw 106
.label1_Code:                   dw 0
;**** Object (Label2) Extra Data Record ****
.Label2_ExtData:                
.Label2_Text:                   dw  Label2_Text_Data+4
.Label2_TextAppearance:         db  18
.Label2_TextAlignment:          db  192
;**** Object (Check1) Extra Data Record ****
.Check1_ExtData:                
.Check1_ValueAddr:              dw  Check1_Value
.Check1_Text:                   dw  Check1_Text_Data+4
.Check1_TextAppearance:         db  6
.Check1_Value:                  dw  1
;**** Object (TextLine1) Extra Data Record ****
.TextLine1_ExtData:             
.TextLine1_Text:                dw  TextLine1_Text_Data+4
.TextLine1_FDC:                 dw  0
.TextLine1_CurPos:              dw  5
.TextLine1_Selected:            dw  0
.TextLine1_InputLen:            dw  5
.TextLine1_InputMax:            dw  24
.TextLine1_Password:            db  0
.TextLine1_Text_Data:           dw  TextLine1_Text:dw 24
.TextLine1_Input:               db  "Text1",0
    ds  19
;**** Object (label1) Extra Data Record ****
.label1_ExtData:                
.label1_Text:                   dw  label1_Text_Data+4 ;0
.label1_Empty1:                 dw  0 ;2
.label1_CurrPos:                dw  0 ;4
.label1_Selected:               dw  0 ;6
.label1_InputLen:               dw  7 ;8
.label1_InputMax:               dw  1024 ;10
.label1_ReadOnly:               db  2 ;12
.label1_TextPalette:            db  0 ;13
.label1_Empty2:                 db  0 ;14
.label1_Font:                   dw  0 ;15
.label1_Empty3:                 db  0 ;17
.label1_Lines:                  dw  1 ;18
.label1_Pixel:                  dw  -1 ;20
.label1_LinesMax:               dw  128 ;22
.label1_Empty4:                 dw  -8 ;24
.label1_Empty5:                 dw  0 ;26
.label1_Empty6:                 dw  label1_ExtData ;28
.label1_Empty7:                 dw  0 ;30
.label1_Empty8:                 dw  0 ;32
.label1_Empty9:                 dw  0 ;34
.label1_Empty10:                dw  0 ;36
.label1_WordWrap:               db  2 ;38
.label1_TabStop:                db  0 ;39
.label1_Empty11:                db  0,0,0,0 ;40
.label1_Empty12:                db  0,0,0,0 ;44
.label1_Line1:                  dw  0 ;48
.label1_Line2:                  dw  0 ;50
.label1_Line3:                  dw  0 ;52
.label1_Line4:                  dw  0 ;54
.label1_Line5:                  dw  0 ;56
.label1_Line6:                  dw  0 ;58
.label1_Line7:                  dw  0 ;60
.label1_Line8:                  dw  0 ;62
.label1_Line9:                  dw  0 ;64
.label1_Line10:                 dw  0 ;66
.label1_Line11:                 dw  0 ;68
.label1_Line12:                 dw  0 ;70
.label1_Line13:                 dw  0 ;72
.label1_Line14:                 dw  0 ;74
.label1_Line15:                 dw  0 ;76
.label1_Line16:                 dw  0 ;78
.label1_Line17:                 dw  0 ;80
.label1_Line18:                 dw  0 ;82
.label1_Line19:                 dw  0 ;84
.label1_Line20:                 dw  0 ;86
.label1_Line21:                 dw  0 ;88
.label1_Line22:                 dw  0 ;90
.label1_Line23:                 dw  0 ;92
.label1_Line24:                 dw  0 ;94
.label1_Line25:                 dw  0 ;96
.label1_Line26:                 dw  0 ;98
.label1_Line27:                 dw  0 ;100
.label1_Line28:                 dw  0 ;102
.label1_Line29:                 dw  0 ;104
.label1_Line30:                 dw  0 ;106
.label1_Line31:                 dw  0 ;108
.label1_Line32:                 dw  0 ;110
.label1_Line33:                 dw  0 ;112
.label1_Line34:                 dw  0 ;114
.label1_Line35:                 dw  0 ;116
.label1_Line36:                 dw  0 ;118
.label1_Line37:                 dw  0 ;120
.label1_Line38:                 dw  0 ;122
.label1_Line39:                 dw  0 ;124
.label1_Line40:                 dw  0 ;126
.label1_Line41:                 dw  0 ;128
.label1_Line42:                 dw  0 ;130
.label1_Line43:                 dw  0 ;132
.label1_Line44:                 dw  0 ;134
.label1_Line45:                 dw  0 ;136
.label1_Line46:                 dw  0 ;138
.label1_Line47:                 dw  0 ;140
.label1_Line48:                 dw  0 ;142
.label1_Line49:                 dw  0 ;144
.label1_Line50:                 dw  0 ;146
.label1_Line51:                 dw  0 ;148
.label1_Line52:                 dw  0 ;150
.label1_Line53:                 dw  0 ;152
.label1_Line54:                 dw  0 ;154
.label1_Line55:                 dw  0 ;156
.label1_Line56:                 dw  0 ;158
.label1_Line57:                 dw  0 ;160
.label1_Line58:                 dw  0 ;162
.label1_Line59:                 dw  0 ;164
.label1_Line60:                 dw  0 ;166
.label1_Line61:                 dw  0 ;168
.label1_Line62:                 dw  0 ;170
.label1_Line63:                 dw  0 ;172
.label1_Line64:                 dw  0 ;174
.label1_Line65:                 dw  0 ;176
.label1_Line66:                 dw  0 ;178
.label1_Line67:                 dw  0 ;180
.label1_Line68:                 dw  0 ;182
.label1_Line69:                 dw  0 ;184
.label1_Line70:                 dw  0 ;186
.label1_Line71:                 dw  0 ;188
.label1_Line72:                 dw  0 ;190
.label1_Line73:                 dw  0 ;192
.label1_Line74:                 dw  0 ;194
.label1_Line75:                 dw  0 ;196
.label1_Line76:                 dw  0 ;198
.label1_Line77:                 dw  0 ;200
.label1_Line78:                 dw  0 ;202
.label1_Line79:                 dw  0 ;204
.label1_Line80:                 dw  0 ;206
.label1_Line81:                 dw  0 ;208
.label1_Line82:                 dw  0 ;210
.label1_Line83:                 dw  0 ;212
.label1_Line84:                 dw  0 ;214
.label1_Line85:                 dw  0 ;216
.label1_Line86:                 dw  0 ;218
.label1_Line87:                 dw  0 ;220
.label1_Line88:                 dw  0 ;222
.label1_Line89:                 dw  0 ;224
.label1_Line90:                 dw  0 ;226
.label1_Line91:                 dw  0 ;228
.label1_Line92:                 dw  0 ;230
.label1_Line93:                 dw  0 ;232
.label1_Line94:                 dw  0 ;234
.label1_Line95:                 dw  0 ;236
.label1_Line96:                 dw  0 ;238
.label1_Line97:                 dw  0 ;240
.label1_Line98:                 dw  0 ;242
.label1_Line99:                 dw  0 ;244
.label1_Line100:                dw  0 ;246
.label1_Line101:                dw  0 ;248
.label1_Line102:                dw  0 ;250
.label1_Line103:                dw  0 ;252
.label1_Line104:                dw  0 ;254
.label1_Line105:                dw  0 ;256
.label1_Line106:                dw  0 ;258
.label1_Line107:                dw  0 ;260
.label1_Line108:                dw  0 ;262
.label1_Line109:                dw  0 ;264
.label1_Line110:                dw  0 ;266
.label1_Line111:                dw  0 ;268
.label1_Line112:                dw  0 ;270
.label1_Line113:                dw  0 ;272
.label1_Line114:                dw  0 ;274
.label1_Line115:                dw  0 ;276
.label1_Line116:                dw  0 ;278
.label1_Line117:                dw  0 ;280
.label1_Line118:                dw  0 ;282
.label1_Line119:                dw  0 ;284
.label1_Line120:                dw  0 ;286
.label1_Line121:                dw  0 ;288
.label1_Line122:                dw  0 ;290
.label1_Line123:                dw  0 ;292
.label1_Line124:                dw  0 ;294
.label1_Line125:                dw  0 ;296
.label1_Line126:                dw  0 ;298
.label1_Line127:                dw  0 ;300
.label1_Line128:                dw  0 ;302
.label1_Text_Data:              dw  label1_Text:dw 1024
.label1_Input:                  db  "Text...",0
    ds  1017
.SyStud_TimerRoutines    dw 0
.AppTrnEnd


