

;*******************************
;**** SymBasic Code .****
;*******************************

;**** Necessary Stuff
.SyB_RamBankInfo
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0		
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
		db		0,0:dw 0,0
.SyB_RamBank_Temp:		dw	0



;****            ****
;**** Mark Error ****
;****            ****
;DE = Error Number
.SyB_Mark_Error
		ld		(ErrorNum),de
		pop		hl						;Gets Return Stack
		ld		(ErrorPC),hl
		ld		a,d
		cp		8
		jp		c,SyB_Mark_Error_1
		di
.SyB_Mark_Error_2		
		jr		.SyB_Mark_Error_2
.SyB_Mark_Error_1
		jp		(hl)
		



;;==============================================================================
;;### SUB-ROUTINES #############################################################
;;==============================================================================
;;### CLCN32 -> Converts 32Bit-number (unsigned) in ASCII-String (teminated by 0)
;;### Input      DE,IX=value, IY=destination address
;;### Output     IY=Address of last char
;;### Destroyed  AF,BC,DE,HL,IX,IY


;.clcn32t
;		dw 		1,0,10,0,100,0,1000,0,10000,0
;       dw 		#86a0,1,#4240,#f,#9680,#98,#e100,#5f5,#ca00,#3b9a
;.clcn32z
;		ds 		4,0
;
;		nop
;		nop
;.clcn32
;		ld 		(clcn32z),ix
 ;      ld 		(clcn32z+2),de
;      ld 		ix,clcn32t+36
;        ld 		b,9
;        ld 		c,0
;.clcn321
;		ld 		a,"0"
;        Or 		a
;.clcn322
;		ld 		e,(ix+0)
;		ld 		d,(ix+1)
;		ld 		hl,(clcn32z)
;		sbc 	hl,de
;		ld 		(clcn32z),hl
 ;      ld 		e,(ix+2)
	;	ld 		d,(ix+3)
;		ld 		hl,(clcn32z+2)
;		sbc 	hl,de
;		ld 		(clcn32z+2),hl
;       jr 		c,clcn325
;        inc 	c
;        inc 	a
;        jr 		clcn322
;.clcn325
;		ld 		e,(ix+0)
;		ld 		d,(ix+1)
;		ld 		hl,(clcn32z)
;		add 	hl,de
;		ld 		(clcn32z),hl
 ;      ld 		e,(ix+2)
;		ld 		d,(ix+3)
;		ld 		hl,(clcn32z+2)
;		adc 	hl,de
;		ld 		(clcn32z+2),hl
;       ld 		de,-4
;        add 	ix,de
;        inc 	c
;        dec 	c
;        jr 		z,clcn323
;        ld 		(iy+0),a
;        inc 	iy
;clcn323
;		djnz 	clcn321
;        ld 		a,(clcn32z)
;        add 	"0"
;        ld 		(iy+0),a
;        ld 		(iy+1),0
;        ret
;;### CLCDEZ -> Converts 8bit value into two decimal digits
;;### Input      A=value
;;### Output     L=10.ascii digit, H=1. ascci digit
;;### Destroyed  AF
;clcdez  ld l,0
;clcdez1 sub 10
;        jr c,clcdez2
;        inc l
;        jr clcdez1
;clcdez2 add "0"+10
;        ld h,a
;        ld a,"0"
;        add l
;        ld l,a
;       ret

	
;******************************************************************************
;*** Name           System_CallFunction
;*** Input          ((SP+0)) = System manager command
;***                ((SP+1)) = Function ID
;***                AF,BC,DE,HL,IX,IY = Input for the function
;*** Output         AF,BC,DE,HL,IX,IY = Output from the function
;*** Destroyed      -
;*** Description    Calls a function via the system manager. This function is
;***                needed to have access to the file manager.
;******************************************************************************
.SySystem_CallFunction
		ld (AppMsgB+04),bc      ;copy registers into the message buffer
        ld (AppMsgB+06),de
        ld (AppMsgB+08),hl
        ld (AppMsgB+10),ix
        ld (AppMsgB+12),iy
        push af
        pop hl
        ld (AppMsgB+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (AppMsgB+00),de      ;module und funktion number
        ld a,e
        ld (SyCallN),a
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #10                 ;send message
SyCall1 rst #30
        ld iy,AppMsgB
        ld a,(AppPrzN)
        db #dd:ld l,a
        ld a,3
        db #dd:ld h,a
        rst #18                 ;wait for answer
        db #dd:dec l
        jr nz,SyCall1
        ld a,(AppMsgB)
        sub 128
        ld e,a
        ld a,(SyCallN)
        cp e
        jr nz,SyCall1
        ld hl,(AppMsgB+02)      ;get registers out of the message buffer
        push hl
        pop af
        ld bc,(AppMsgB+04)
        ld de,(AppMsgB+06)
        ld hl,(AppMsgB+08)
        ld ix,(AppMsgB+10)
        ld iy,(AppMsgB+12)
        ret
SyCallN db 0


